package jalview.ws.api;

import jalview.datamodel.SequenceI;
import jalview.ws.params.ArgumentI;
import jalview.ws.params.WsParamSetI;

import java.util.List;

/**
 * MSA analysis interface
 * 
 * @author jprocter
 * 
 *         Generic job submission/management model: - A service instance
 *         implements one or more analysis interfaces, a status interface, a
 *         progress interface, and one or more results interface, plus any
 *         informational/descriptional interfaces - analysis interfaces return
 *         JobId or throw exceptions/errors.
 * 
 *
 */
public interface MsaI
{
  /**
   * Given a set of sequences
   * 
   * @param toalign
   * @param parameters
   * @param list
   * @return JobId or exceptions are thrown.
   * @throws Throwable
   */
  public JobId align(List<SequenceI> toalign, WsParamSetI parameters,
          List<ArgumentI> list)
          throws Throwable;
}
